#!/usr/bin/env python

#Crosslinker FM Copyright (c) 2015 JJ Posti <techtimejourney.net> 
#Crosslinker is a python file manager.The program comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")


#IMPORTING MODULES

import pygtk, os, gtk, subprocess, shutil, errno
pygtk.require('2.0')

class CrosslinkerFM:

###################
#RENAME FUNCTION
##################
 
    def rename_selects(self,widget):
        global sourcemove
        sourcemove=self.filea.get_filename()
        self.renamer.set_text(sourcemove)
        print sourcemove
   	    
    def actual_rename (self, widget, data=None):
        destroy_dialog = gtk.MessageDialog(self.window1, gtk.DIALOG_MODAL,
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,
                                   "If an object with the same name is found on the rename destination it will be overwritten. Are you sure you want to continue?")
        destroy_dialog.set_title("Rename an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()
        if response == gtk.RESPONSE_YES:		
            global getsit1
            getsit1=self.renamer.get_text()
            done=os.renames(sourcemove,getsit1)
            return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event" 
				
###########################
#LOCATION FUNCTION  
#######################

    def going(self,widget):
        global goingdest
        goingdest=self.filea.get_current_folder()
        os.chdir(goingdest)
        self.location1.set_text(goingdest)
        print goingdest
   	    
    def actual_going(self,widget):		
        global get_going
        get_going=self.location1.get_text()
        hereigo=str(os.chdir(get_going))
        self.filea.set_current_folder(hereigo)
 
  
######################
#MOVE FUNCTION
######################
#Move function
    def movesource(self,widget):
        global sourcemove2
        sourcemove2=self.filea.get_filename()

    def movedestination(self, widget, data=None):
        destroy_dialog = gtk.MessageDialog(self.window1, gtk.DIALOG_MODAL,
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,
                                   "If an object with the same name is found on the move destination it will be overwritten. Are you sure you want to continue?")
        destroy_dialog.set_title("Move an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()
        if response == gtk.RESPONSE_YES:		
		    movedest=self.filea.get_current_folder()
		    os.chdir(movedest)
		    shutil.move(sourcemove2,movedest)
		    return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event" 
##################################
#PASTE FUNCTION
##########################
    def copydestination(self, widget, data=None):
        destroy_dialog = gtk.MessageDialog(self.window1, gtk.DIALOG_MODAL,
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,
                                   "If an object with the same name is found on the paste destination it will be overwritten. Are you sure you want to continue?")
        destroy_dialog.set_title("Paste an object?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()
        if response == gtk.RESPONSE_YES:
            try:
                copydest=self.filea.get_current_folder()
                os.chdir(copydest)
                subprocess.Popen(['cp', '-r', sourcemove2 , copydest])
            except OSError as e:
                if e.errno == errno.ENOTDIR:		
                    copydest=self.filea.get_current_folder()
                    os.chdir(copydest)
                    shutil.copy(sourcemove2,copydest)
                    return False # returning False and make destroy-event
            else:
                   return True # returning True and avoid "destroy-event"                       			              
##############################
#CREATE OBJECT FUNCTIONS
#################################
#Make new directory
    def newdir(self,widget):
		foldername=self.filea.get_current_folder()
		os.chdir(foldername)
		makefolder=os.makedirs('Newfolder')
		print os.getcwd()
		makefolder           

#Make new empty text file
    def newfile(self,widget):
        foldername=self.filea.get_current_folder()
        os.chdir(foldername)
        newtext=os.mknod('Newtext.txt')
        print os.getcwd()
        newtext
####################
#DELETE FUNCTIONS
##########################
#Destroy/Delete file function
    def foreverfile (self, widget, data=None):
        destroy_dialog = gtk.MessageDialog(self.window1, gtk.DIALOG_MODAL,
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,
                                   "Delete this PERMANENTLY?")
        destroy_dialog.set_title("DELETE FILE?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()
        if response == gtk.RESPONSE_YES:
            filename=self.filea.get_filename()
            os.remove(filename)
            return False # returning False and make destroy-event

        else:
            return True # returning True and avoid "destroy-event"

#Destroy/Delete folder function
    def foreverfolder (self, widget, data=None):
        destroy_dialog = gtk.MessageDialog(self.window1, gtk.DIALOG_MODAL,
                                   gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO,
                                   "Delete this PERMANENTLY?")
        destroy_dialog.set_title("DELETE FOLDER?")
        response = destroy_dialog.run()
        destroy_dialog.destroy()
        if response == gtk.RESPONSE_YES:
            foldername=self.filea.get_filename()
            shutil.rmtree(foldername)
            return False # returning False and make destroy-event
        else:
            return True # returning True and avoid "destroy-event"
###########################################################################
#POWER MANAGEMENT FUNCTIONS
############################################
#Shutdown function
    def power(self,widget):
		subprocess.Popen(['gksudo', 'poweroff'])
	
#Reboot function
    def reboot(self,widget):
        subprocess.Popen(['gksudo', 'reboot'])
        
#Suspend function
    def suspend(self,widget):
        subprocess.Popen(['gksudo', 'pm-suspend'])
###########################################################
#GENERAL FUNCTIONS
#####################################
#Close function
    def destroy (self, widget, data=None):
        gtk.main_quit()
            	        
#About dialog function
    def about1 (self, widget):
        about1 = gtk.AboutDialog()
        about1.set_program_name("Crosslinker FM")
        about1.set_version("V.2015-Nov")
        about1.set_copyright(" Copyright (c) 2015 JJ Posti <techtimejourney.net>")
        about1.set_comments("Crosslinker is a python file-manager.The program comes with ABSOLUTELY NO WARRANTY; for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991")
        about1.set_website("www.techtimejourney.net")
        about1.run()
        about1.destroy()
        
#Sound selector function
    def sound (self, widget):
        sound=subprocess.Popen(['terminator', '-x', 'bash', '/usr/share/sound-selector.sh'])

#Simple mount function
    def mount (self, widget):
        mount=subprocess.Popen(['terminator', '-x', 'bash', '/usr/share/mount.sh'])

#Terminal menu item function
    def terminal (self, widget):
        terminal=subprocess.Popen(["x-terminal-emulator"])
        
#Geany function
    def geany (self, widget):
        geany=subprocess.Popen("geany")
		
#Browser function
    def browser (self, widget):
        browser=subprocess.Popen("x-www-browser")

#Qpdfview  function
    def qpdf (self, widget):
        qpdf=subprocess.Popen("qpdfview")
		 
#I3lock function
    def locked (self, widget):
        locked=subprocess.Popen(['i3lock', '-c', '202020', '-n'])               
##############################################################################
###OPEN WITH FUNCTIONS
########################
#OPEN WITH GEANY 
    def dialog_geany (self,widget):
        filename=self.filea.get_filename()
        subprocess.Popen(['geany', filename])   
        
#OPEN IMAGE WITH FEH
    def dialog_feh (self,widget):
        filename=self.filea.get_filename()
        subprocess.Popen(['feh', filename])
 
#OPEN with Vlc
    def vlc (self,widget):
        filename=self.filea.get_filename()
        subprocess.Popen(['vlc', filename]) 

#Open with Browser
    def fireopen (self,widget):
        filename=self.filea.get_filename()
        subprocess.Popen(['x-www-browser', filename]) 

#Web search
    def search(self,widget):
		subprocess.Popen(['x-www-browser', 'www.techtimejourney.net/audax'])                             
 
        
####################################
#STARTING WINDOW DEFINITIONS
#################################
#GENERAL STUFF
#################################    
    def __init__(self):    
    # Create THE WINDOW
        self.window1 = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window1.set_position(gtk.WIN_POS_CENTER)
        self.window1.set_size_request(920, 640)
        self.window1.set_title("Crosslinker FM")
        self.window1.connect("delete_event", self.destroy)
#Toolbars
        self.toolbar=gtk.Toolbar()
        self.toolbar2=gtk.Toolbar()
#Create menubar
        self.bar=gtk.MenuBar()

###############################
#FILE MANAGER
#################################       
# Create a new file selection widget        
        self.filea = gtk.FileChooserWidget()      
#Additional features
        self.filea.set_current_folder("/home/")
        self.filea.set_select_multiple(True)                                 
        self.filea.set_size_request(600, 490)
################################
###MENUS
###############

###FILE MENU
    #Create menu items for File menu

        self.file_menu=gtk.Menu()
        self.filemenu=gtk.MenuItem("File")
        self.filemenu.set_submenu(self.file_menu)
 
#Buttons for File menu

#Close button for file menu

        self.away=gtk.MenuItem("Close")
        self.away.connect("activate", gtk.main_quit)

#About button for file menu

        self.about=gtk.MenuItem("About")
        self.about.connect("activate", self.about1)

#New Folder
        self.newfolder1=gtk.MenuItem("New folder")
        self.newfolder1.connect("activate", self.newdir)

#New text file
        self.newfile1=gtk.MenuItem("New text file")
        self.newfile1.connect("activate", self.newfile)        

#Appending things to File_menu        
        self.file_menu.append(self.newfolder1)
        self.file_menu.append(self.newfile1)
        self.file_menu.append(gtk.SeparatorMenuItem())
        self.file_menu.append(self.about)
        self.file_menu.append(self.away)
#############################
####ADMIN MENU
#############################
#Create menu items for File menu
        
        self.admin1=gtk.Menu()
        self.admin=gtk.MenuItem("Admin")
        self.admin.set_submenu(self.admin1)		

#Buttons for admin menu

    #Terminal button for admin menu
        self.menuterm=gtk.MenuItem("Open terminal")
        self.menuterm.connect("activate", self.terminal)
 
    #i3lock button for admin menu
        self.lock=gtk.MenuItem("Lock screen")
        self.lock.connect("activate", self.locked)

    #Sound button for admin menu
        self.sound1=gtk.MenuItem("Sound management")
        self.sound1.connect("activate", self.sound)  

# Power button
        self.powers= gtk.MenuItem("Poweroff computer")
        self.powers.connect("activate", self.power)
        
# Reboot button
        self.reboots= gtk.MenuItem("Reboot computer")
        self.reboots.connect("activate", self.reboot)
        
# Suspend button
        self.suspends= gtk.MenuItem("Suspend computer")
        self.suspends.connect("activate", self.suspend)     

#Appending things to Admin menu
		
        self.admin1.append(self.menuterm)
        self.admin1.append(self.lock)
        self.admin1.append(self.sound1)
        self.admin1.append(gtk.SeparatorMenuItem())
        self.admin1.append(self.suspends)
        self.admin1.append(self.reboots)
        self.admin1.append(self.powers)
###############################################
#Actions menu
##############################################
#Open with Geany 
        self.open_geany=gtk.MenuItem("Open with Geany")
        self.open_geany.connect("activate", self.dialog_geany)

#Open with Feh
        self.open_feh=gtk.MenuItem("Open with Feh")
        self.open_feh.connect("activate", self.dialog_feh)

#Open with Vlc
        self.open_vlc=gtk.MenuItem("Open with Vlc")
        self.open_vlc.connect("activate", self.vlc)

#Open with Browser
        self.open_browser=gtk.MenuItem("Open with web browser")
        self.open_browser.connect("activate", self.fireopen)

#Open search 
        self.open_search=gtk.MenuItem("Search Online")
        self.open_search.connect("activate", self.search)       

#Actions menu
        self.actions1=gtk.Menu()
        self.actions=gtk.MenuItem("Actions")
        self.actions.set_submenu(self.actions1)	
        
#Appending things to Actions menu
        self.actions1.append(self.open_feh)
        self.actions1.append(self.open_geany)
        self.actions1.append(self.open_vlc)
        self.actions1.append(gtk.SeparatorMenuItem())
        self.actions1.append(self.open_browser)
        self.actions1.append(self.open_search)
######################################################
#Appending items to menubar
        self.bar.append(self.filemenu)
        self.bar.append(self.actions)
        self.bar.append(self.admin)
#######################################################
#BUTTONS APPEARING ON THE FILE MANAGER TOOLBAR
###################################################
#New text file button
        self.newtext01_button=gtk.ToolButton(gtk.STOCK_EDIT)
        self.newtext01_button.connect("clicked", self.newfile)
        self.toolbar2.insert(self.newtext01_button, -1)

#New folder button
        self.newfolder01_button=gtk.ToolButton(gtk.STOCK_DIRECTORY)
        self.newfolder01_button.connect("clicked", self.newdir)
        self.toolbar2.insert(self.newfolder01_button, -1)       

#Separator
        self.separator=gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator, -1)

#Copy/Select for moving
        self.copy_button=gtk.ToolButton(gtk.STOCK_COPY)
        self.copy_button.connect("clicked", self.movesource)
        self.toolbar2.insert(self.copy_button, -1)
# Paste
        self.paste_button=gtk.ToolButton(gtk.STOCK_PASTE)
        self.paste_button.connect("clicked", self.copydestination)
        self.toolbar2.insert(self.paste_button, -1)
#Move        
        self.move_button=gtk.ToolButton(gtk.STOCK_REFRESH)
        self.move_button.connect("clicked", self.movedestination)
        self.toolbar2.insert(self.move_button, -1)
        
#Separator
        self.separator2=gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator2, -1)

#Delete file button
        self.delete1_button=gtk.ToolButton(gtk.STOCK_DIALOG_ERROR)
        self.delete1_button.connect("clicked", self.foreverfile)
        self.toolbar2.insert(self.delete1_button, -1)

#Delete folder button
        self.delete2_button=gtk.ToolButton(gtk.STOCK_DIALOG_WARNING)
        self.delete2_button.connect("clicked", self.foreverfolder)
        self.toolbar2.insert(self.delete2_button, -1)
        
#Separator
        self.separator3=gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator3, -1)
              
#Geany button       
        self.open_geany_button=gtk.ToolButton(gtk.STOCK_DND)
        self.open_geany_button.connect("clicked", self.dialog_geany)
        self.toolbar2.insert(self.open_geany_button, -1)
        
#Feh button       
        self.open_feh_button=gtk.ToolButton(gtk.STOCK_EXECUTE)
        self.open_feh_button.connect("clicked", self.dialog_feh)
        self.toolbar2.insert(self.open_feh_button, -1)
                
#Vlc button       
        self.open_vlc_button=gtk.ToolButton(gtk.STOCK_MEDIA_PLAY)
        self.open_vlc_button.connect("clicked", self.vlc)
        self.toolbar2.insert(self.open_vlc_button, -1)
        
#WWW button       
        self.open_www_button=gtk.ToolButton(gtk.STOCK_CONNECT)
        self.open_www_button.connect("clicked", self.fireopen)
        self.toolbar2.insert(self.open_www_button, -1)
                
#WWW search button       
        self.searching_www_button=gtk.ToolButton(gtk.STOCK_INFO)
        self.searching_www_button.connect("clicked", self.search)
        self.toolbar2.insert(self.searching_www_button, -1)
        
#Separator
        self.separator4=gtk.SeparatorToolItem()
        self.toolbar2.insert(self.separator4, -1)
        
#Lock screen button       
        self.locking_button=gtk.ToolButton(gtk.STOCK_DIALOG_AUTHENTICATION)
        self.locking_button.connect("clicked", self.locked)
        self.toolbar2.insert(self.locking_button, -1)      
##############
#RENAME BAR
################
#Rename bar
        self.renamer=gtk.Entry()

#Rename_Selects button
        self.rbutton1=gtk.Button("Select for rename ")        
        self.rbutton1.connect("clicked", self.rename_selects)
#Rename_Does button
        self.rbutton2=gtk.Button("Rename selected")        
        self.rbutton2.connect("clicked", self.actual_rename)             
#####################
####LOCATIION BAR
######################
        
        self.location1=gtk.Entry()

#Go button
        self.locateme=gtk.Button("Go")        
        self.locateme.connect("clicked", self.actual_going)
#Separator
        self.separateus=gtk.HSeparator()
         
#########################################
#UPPER toolbar buttons and texts
#########################################       
# Geany button
        self.geany_button= gtk.Button("Open Geany")
        self.geany_button.connect("clicked", self.geany)

# Qpdfview button
        self.qpdf_button= gtk.Button("Open Qpdfview")
        self.qpdf_button.connect("clicked", self.qpdf)

# Browser button
        self.www_button= gtk.Button("Open web browser")
        self.www_button.connect("clicked", self.browser)
        
# Simple_mount button
        self.mount_button= gtk.Button("Open Simple mount")
        self.mount_button.connect("clicked", self.mount)        
################################################################################
#TOOLTIPS FOR BUTTONS UNDER TOOLBAR2
#######################################
#New text or folder
        self.newtext01_button.set_tooltip_text ("Create new text file")
        self.newfolder01_button.set_tooltip_text ("Create new folder")

#Copy/Move and Paste
        self.paste_button.set_tooltip_text ("Paste a copy to location")
        self.copy_button.set_tooltip_text ("Copy/Select for moving")
        self.move_button.set_tooltip_text ("Move object to the location")

#Others        
        self.open_geany_button.set_tooltip_text ("Open with Geany")
        self.open_feh_button.set_tooltip_text ("Open with Feh")
        self.open_vlc_button.set_tooltip_text ("Open with Vlc")
        self.open_www_button.set_tooltip_text ("Open with Web browser")
        self.searching_www_button.set_tooltip_text ("Search Online")
        self.locking_button.set_tooltip_text ("Lock screen")


#Delete buttons
        self.delete1_button.set_tooltip_text ("Delete file permanently")
        self.delete2_button.set_tooltip_text ("Delete folder permanently")
        
  
################################################################################
#TOOLTIPS FOR BUTTONS UNDER TOOLBAR1
#######################################
        self.www_button.set_tooltip_text ("Open web browser")
        self.geany_button.set_tooltip_text ("Open Geany text editor")
        self.qpdf_button.set_tooltip_text ("Open Pdf viewer")
        self.mount_button.set_tooltip_text ("Open Simple mount")        	
###########################
#BOX CONTAINERS 
############################
# Verical box2 for file manager       
        self.vbox2=gtk.VBox(False)
        self.vbox2.pack_start(self.toolbar2,False, False, 0)

###Main container1 --- placing stuff to the main window
        self.hbox=gtk.HBox()
        self.hbox.pack_start(self.geany_button, False, False, 1)
        self.hbox.pack_start(self.qpdf_button, False, False, 1)
        self.hbox.pack_start(self.www_button, False, False, 1)
        self.hbox.pack_start(self.mount_button, False, False, 1)
        self.hbox.pack_start(self.renamer, False, False, 1)
        self.hbox.pack_start(self.rbutton1, False, False, 1)
        self.hbox.pack_start(self.rbutton2, False, False, 1)
        self.hbox.pack_start(self.separateus, False, False, 1)
        
        ###Location bar container
        self.hbox2=gtk.HBox()
        self.hbox2.pack_end(self.location1,True, True, 2)
        self.hbox2.pack_start(self.locateme,False, True, 2)

 		#Vertical box/buttons container
        self.vbox=gtk.VBox(False)
        
        self.vbox.pack_start(self.bar, False, False, 1)   
        self.vbox.pack_start(self.hbox, False, False, 2)
        self.vbox.pack_start(self.hbox2, False, False, 2)
        self.vbox.pack_start(self.filea, False, False, 2)
        self.vbox.pack_start(self.vbox2, False, False, 2)

#Show everything		
        self.window1.add(self.vbox)
        self.window1.show_all()
         
#Making window resizable and enabling the close window connector        
        self.window1.set_resizable(True)
        self.window1.connect("destroy", self.destroy)

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    CrosslinkerFM()
    main()
